C
C SUBROUTINE TO MAKE ROTATION VECTOR FOR DISPLAY ON RASMOL
C
       SUBROUTINE ARROW(NBB,COOBB1,UNTHX,UNTHY,UNTHZ,
     &         XL,YL,ZL,RESPDBNUM,NRES,IPAIR,
     &         CHAINID,IOUT6,IOUT3,COLORA,COLORB)
C
       IMPLICIT NONE
C
       include 'DynDom.param'
C
       REAL*8 MASS(2),RMSD
       REAL*8 UNTHX,UNTHY,UNTHZ                       
       REAL*8 XL,YL,ZL                       
       REAL*8 X(100),Y(100),Z(100)
       REAL*8 COOBB1(3,*)
       REAL*8 COA(3,2)
       REAL*8 CO(3,2)
       REAL*8 COOA(3,6)
       REAL*8 TMAX,TMIN,ARRWIDTH,FITLGH,SHARP,T,T1,ARC
       INTEGER NBB,NARR,NFIT,N,I,M,L
       INTEGER NRES,IPAIR,LASTRES
       INTEGER IOUT6,IOUT3
       CHARACTER*5 RESPDBNUM(*)
       CHARACTER*19 COLORA,COLORB
       CHARACTER*1 CHAINID
C
 	SAVE LASTRES
C
        MASS(1)=1.0
        MASS(2)=1.0
C
        ARRWIDTH=1.0
        SHARP=3.0
        FITLGH=3.0
        NFIT=2
        NARR=6
C                                                                       
C CALL ROUTINE TO DETERMINE LENGTH OF AXIS
C
        CALL AXLENG(NBB,COOBB1,UNTHX,UNTHY,UNTHZ,XL,YL,ZL,TMAX,TMIN)
C
        T=FITLGH
        T1=TMIN
        N=(TMAX-TMIN)/FITLGH
101     CONTINUE
        IF(N.LT.2) THEN
          TMIN=TMIN-(TMAX-TMIN)/10.0
          TMAX=TMAX+(TMAX-TMIN)/10.0
          N=(TMAX-TMIN)/FITLGH
          GOTO 101
        ENDIF
C
        DO 10 I=1,N
          X(I)=UNTHX*T1+XL
          Y(I)=UNTHY*T1+YL
          Z(I)=UNTHZ*T1+ZL
          T1=T1+T
10      CONTINUE
C
        CO(1,1)=X(N)
        CO(2,1)=Y(N)
        CO(3,1)=Z(N)
        CO(1,2)=X(N-1)
        CO(2,2)=Y(N-1)
        CO(3,2)=Z(N-1)
C
        COA(1,1)=0.01
        COA(2,1)=0.01 
        COA(3,1)=0.01
        COA(1,2)=0.0
        COA(2,2)=FITLGH 
        COA(3,2)=0.0
C
        COOA(1,1)=0.01
        COOA(2,1)=0.01 
        COOA(3,1)=0.01
        COOA(1,2)=0.0
        COOA(2,2)=FITLGH 
        COOA(3,2)=0.0
C
        ARC=2*PI/4 
        M=0
        DO 112 I=3,6
          M=M+1
          COOA(1,I)=ARRWIDTH*COS(ARC*M)
          COOA(2,I)=SHARP
          COOA(3,I)=ARRWIDTH*SIN(ARC*M)
112     CONTINUE
C
        CALL FITPART(NFIT,NARR,CO,COA,COOA,MASS,RMSD)
C
C WRITE OUT "ARROW MOLECULE" TO BE APPENDED TO PDB FILE OF CHAIN 1
C
        IF(IPAIR.EQ.1) THEN
          READ(RESPDBNUM(NRES)(1:),*)LASTRES
        ENDIF
C
        L=LASTRES
        WRITE(IOUT6,'(A)')'TER arrow molecule that represents hinge axis
     & for movement from conformer 1 to 2'
        DO 11 I=1,N
          L=L+1
          WRITE(IOUT6,2000)'ATOM','CA  ','GLY ',CHAINID,L,
     &                   X(I),Y(I),Z(I)
11      CONTINUE
C
        WRITE(IOUT6,3000)'TER ARROW SHAFT '
C
        DO 12 I=3,NARR
          L=L+1
          WRITE(IOUT6,2000)'ATOM','CA  ','GLY ',CHAINID,L,
     &                   COOA(1,I),COOA(2,I),COOA(3,I)
          L=L+1
          WRITE(IOUT6,2000)'ATOM','CA  ','GLY ',CHAINID,L,
     &                   X(N),Y(N),Z(N)
          L=L+1
          WRITE(IOUT6,2000)'ATOM','CA  ','GLY ',CHAINID,L,
     &                   COOA(1,I),COOA(2,I),COOA(3,I)
12      CONTINUE
        L=L+1
        WRITE(IOUT6,2000)'ATOM','CA  ','GLY ',CHAINID,L,
     &                 COOA(1,3),COOA(2,3),COOA(3,3)
C
        WRITE(IOUT6,3000)'TER ARROW HEAD '
C
C WRITE OUT SCRIPT FOR RASMOL DISPLAY
C
        WRITE(IOUT3,'(A)')'# select and colour arrow'
        WRITE(IOUT3,5000)'select ',LASTRES+1,'-',LASTRES+N-1,CHAINID
        WRITE(IOUT3,6000)COLORA
        WRITE(IOUT3,5000)'select ',LASTRES+N,'-',L,CHAINID
        WRITE(IOUT3,6000)COLORB
C
        LASTRES=L
C
2000    FORMAT(A4,9X,A4,A4,A1,I4,4X,3F8.3) 
3000    FORMAT(A15) 
5000    FORMAT(A7,I4,A1,I4,A1) 
6000    FORMAT(A19)
C
        RETURN
        END
C
C-------------------------------------------------------------
C
C                       
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
