C
C     FOR MASS WEIGHTED BEST FIT
C
      SUBROUTINE BSTFT (N,CO1,CB2,RMSD,XC1,XC2,R,IER,MASS)
C 
      IMPLICIT NONE
C
      REAL*8 DA(3,3), DU(3,3), DV(3,3), DD(3), DWK(3)
      REAL*8 R(3,*)
      REAL*8 CO1(3,*), CB2(3,*)
      REAL*8 XC1(*), XC2(*), C(3)
      REAL*8 MASS(*),MASSTOT,RMSD,DELTA
      REAL*8 B13,B23,B33,S     
      REAL*8 A13,A23,A33   
      REAL*8 TEMP(3)
      INTEGER I,J,K,N,NA,II,I1,J1,IER,LIST(3)
      LOGICAL MATU,MATV
C
      MATU=.TRUE.
      MATV=.TRUE.
C 
      DO 10 K=1,3
        XC1(K)=0.
        XC2(K)=0.
10    CONTINUE
      DO 30 NA=1,N
        DO 20 K=1,3
          XC1(K)=XC1(K)+CO1(K,NA)*MASS(NA)
          XC2(K)=XC2(K)+CB2(K,NA)*MASS(NA)
20      CONTINUE
30    CONTINUE
C
      MASSTOT=0.D0
C 
      DO 40 II=1,N
        MASSTOT=MASSTOT+MASS(II)
40    CONTINUE
C
      DO 50 K=1,3
        XC1(K)=XC1(K)/MASSTOT
        XC2(K)=XC2(K)/MASSTOT
50    CONTINUE
C 
      DO 70 NA=1,N
        DO 60 K=1,3
          CO1(K,NA)=CO1(K,NA)-XC1(K)
          CB2(K,NA)=CB2(K,NA)-XC2(K)
60      CONTINUE
70    CONTINUE
C
      DO 80 I=1,3
        DO 80 J=1,3
        DA(I,J)=0.0
80    CONTINUE
C 
      DO 100 NA=1,N
C 
        DO 90 I=1,3
          DO 90 J=1,3
          DA(I,J)=DA(I,J)+CO1(I,NA)*CB2(J,NA)*MASS(NA)
90      CONTINUE
100   CONTINUE
C
      CALL SVD(3,3,3,DA,DD,MATU,DU,MATV,DV,IER,DWK)
C
      LIST(1)=1
      LIST(2)=2
      LIST(3)=3
      TEMP(1)=DD(1)
      TEMP(2)=DD(2)
      TEMP(3)=DD(3)
      CALL SORTR(3,TEMP,LIST)
C
      A13=DV(2,LIST(1))*DV(3,LIST(2))-DV(3,LIST(1))*DV(2,LIST(2))
      A23=DV(3,LIST(1))*DV(1,LIST(2))-DV(1,LIST(1))*DV(3,LIST(2))
      A33=DV(1,LIST(1))*DV(2,LIST(2))-DV(2,LIST(1))*DV(1,LIST(2))
      S=A13*DV(1,LIST(3))+A23*DV(2,LIST(3))+A33*DV(3,LIST(3))
      DV(1,LIST(3))=A13
      DV(2,LIST(3))=A23
      DV(3,LIST(3))=A33
C----
      B13=DU(2,LIST(1))*DU(3,LIST(2))-DU(3,LIST(1))*DU(2,LIST(2))
      B23=DU(3,LIST(1))*DU(1,LIST(2))-DU(1,LIST(1))*DU(3,LIST(2))
      B33=DU(1,LIST(1))*DU(2,LIST(2))-DU(2,LIST(1))*DU(1,LIST(2))
      S=B13*DU(1,LIST(3))+B23*DU(2,LIST(3))+B33*DU(3,LIST(3))
      DU(1,LIST(3))=B13
      DU(2,LIST(3))=B23
      DU(3,LIST(3))=B33
C
      DO 120 I=1,3
        DO 120 J=1,3
        R(I,J)=DU(I,LIST(1))*DV(J,LIST(1))+DU(I,LIST(2))*DV(J,LIST(2))
     &   +DU(I,LIST(3))*DV(J,LIST(3))
120   CONTINUE
C
      RMSD=0
      DO 170 NA=1,N
        DO 140 I1=1,3
          C(I1)=0.0
          DO 130 J1=1,3
            C(I1)=C(I1)+R(I1,J1)*CB2(J1,NA)
130       CONTINUE
140     CONTINUE
C
        DO 150 I1=1,3
          CB2(I1,NA)=C(I1)
150     CONTINUE
C
        DO 160 I1=1,3
          DELTA=C(I1)-CO1(I1,NA)
          RMSD=RMSD+DELTA*DELTA
160     CONTINUE
170   CONTINUE
C
      RMSD=SQRT(RMSD/N)
C
      RETURN
      END
