C                                                                       
C THIS FINDS THE DISTANCE BETWEEN THE CLOSURE AXIS AND THE LINE
C JOINING THE CENTRES OF MASS OF THE TWO DOMAINS.  IT ALSO FINDS 
C THE ANGLE BETWEEN THESE TWO LINES AND THE COMPONENTS OF THE ROTATION
C ABOUT THE INTERDOMAIN ROTATION AXIS THAT ARE THE TWIST AND CLOSURE MOTION
C
       SUBROUTINE CLOSURE(DOMA,DOMB,NSEG,IRESBEG,IRESEND,CA,
     &  COOBB1,UNTHX,UNTHY,UNTHZ,XL,YL,ZL,IOUT1)
C
       IMPLICIT NONE
C
       include 'DynDom.param'
C
       INTEGER DOMA,DOMB,CA(*),IA,IB,ISEG,IRES
       INTEGER IRESBEG(NDOMX,*),IRESEND(NDOMX,*),NSEG(*)
       INTEGER IOUT1
       REAL*8 COOBB1(3,*)
       REAL*8 UNTHX,UNTHY,UNTHZ,AXAN,AXDIST,CLOSEPER
       REAL*8 CLOSX,CLOSY,CLOSZ 
       REAL*8 XD,YD,ZD,RL,UNCMX,UNCMY,UNCMZ,GTW                       
       REAL*8 XL,YL,ZL,XCMA,YCMA,ZCMA,XCMB,YCMB,ZCMB                       
C                                                                       
C CALCULATE APPROXIMATE LOCATIONS OF CENTRES OF MASS OF THE TWO DOMAINS 
C JUST USING C-ALPHA ATOMS
C
        XCMA=0.0
        YCMA=0.0
        ZCMA=0.0
        IA=0
        DO 20 ISEG=1,NSEG(DOMA)
          DO 10 IRES=IRESBEG(DOMA,ISEG),IRESEND(DOMA,ISEG)
            IA=IA+1
            XCMA=XCMA+COOBB1(1,CA(IRES))
            YCMA=YCMA+COOBB1(2,CA(IRES))
            ZCMA=ZCMA+COOBB1(3,CA(IRES))
10        CONTINUE
20      CONTINUE
C
        XCMA=XCMA/IA
        YCMA=YCMA/IA
        ZCMA=ZCMA/IA
C
        XCMB=0.0
        YCMB=0.0
        ZCMB=0.0
        IB=0
        DO 21 ISEG=1,NSEG(DOMB)
          DO 11 IRES=IRESBEG(DOMB,ISEG),IRESEND(DOMB,ISEG)
            IB=IB+1
            XCMB=XCMB+COOBB1(1,CA(IRES))
            YCMB=YCMB+COOBB1(2,CA(IRES))
            ZCMB=ZCMB+COOBB1(3,CA(IRES))
11        CONTINUE
21      CONTINUE
C
        XCMB=XCMB/IB
        YCMB=YCMB/IB
        ZCMB=ZCMB/IB
C 
C DETERMINE UNIT VECTOR OF LINE JOINING CENTRES OF MASS OF TWO DOMAINS
C
        XD=XCMB-XCMA
        YD=YCMB-YCMA
        ZD=ZCMB-ZCMA
        RL=SQRT(XD**2+YD**2+ZD**2)
        UNCMX=XD/RL
        UNCMY=YD/RL
        UNCMZ=ZD/RL
C 
C DETERMINE ANGLE BETWEEN AXIS AND LINE JOINING CENTRES OF MASS
C
        GTW=UNTHX*UNCMX+UNTHY*UNCMY+UNTHZ*UNCMZ
        AXAN=ACOS(GTW)  
        AXAN=AXAN*180.0/PI
        IF (AXAN.GT.90.0) AXAN=180.0-AXAN
C
C DETERMINE COMPONENT OF INTERDOMAIN ROTATION ALONG LINE JOINING 
C CENTRES OF MASS, I.E. THE TWIST; AND LINE PERPENDICULAR, I.E
C CLOSURE MOTION
C
        CLOSX=UNTHX-GTW*UNCMX
        CLOSY=UNTHY-GTW*UNCMY
        CLOSZ=UNTHZ-GTW*UNCMZ
        CLOSEPER=CLOSX**2+CLOSY**2+CLOSZ**2
        CLOSEPER=CLOSEPER*100
C
C DETERMINE DISTANCE BETWEEN AXIS AND LINE JOINING CENTRES OF MASS
C
        CALL LINEDIST(UNTHX,UNTHY,UNTHZ,UNCMX,UNCMY,UNCMZ,XL,YL,ZL
     &,XCMA,YCMA,ZCMA,AXDIST)
C
       WRITE (IOUT1,'(A58,F8.3)') 'ANGLE BETWEEN SCREW AXIS AND LINE JOI
     &NING CENTRES OF MASS:',AXAN
       WRITE (IOUT1,'(A61,F8.3,A2)') 'DISTANCE BETWEEN SCREW AXIS AND LI
     &NE JOINING CENTRES OF MASS:',AXDIST,' A'
       WRITE (IOUT1,'(A26,F8.3)') 'PERCENTAGE CLOSURE MOTION:',CLOSEPER
C
        RETURN
        END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
